<template>
  <div class="bg-primary q-pa-md justify-start">
    <h4 class="text-info">{{title}}</h4>
    <div>
      <q-input v-model="fileList" type="file" id="fileInput" @change="getFileContent"/>
    </div>
    <p>
      {{status}}
    </p>
    <q-btn color="primary" icon="check" label="OK" @click="overwriteStore" />
  </div>
</template>

<script>
export default {
  props: {
    title: {
      default: "File Reader",
      type: String
    },
    defaultText: {
      default: "No file loaded yet"
    }
  },
  data() {
    return {
      fileList: undefined,
      content: "",
      status: ""
    }
  },
  methods: {
    overwriteStore: function () {
      if (this.content === "" || this.content === undefined) {
        return;
      }
      var data = JSON.parse(this.content);
      var payload = JSON.parse(data['vuex']);
      this.$store.commit('overwriteAll', payload);
      this.$emit('done');
    },
    getFileContent: function () {
      if (this.fileList === undefined) {
        this.status = this.defaultText;
        return;
      }

      var text = "empty"
      var reader = new FileReader();
      reader.onload = (e) => {
        this.content = reader.result;
        this.status = "okay";
      }

      var file = this.fileList[0];
      reader.readAsText(file)
    }
  }

}
</script>

<style>

</style>
